use strafesnet_graphics::graphics;
use strafesnet_session::session;
use strafesnet_settings::settings;

pub enum Instruction{
	Render(session::FrameState),
	//UpdateModel(graphics::GraphicsModelUpdate),
	Resize(winit::dpi::PhysicalSize<u32>,settings::UserSettings),
	ChangeMap(strafesnet_common::map::CompleteMap),
}

//Ideally the graphics thread worker description is:
/*
WorkerDescription{
	input:Immediate,
	output:Realtime(PoolOrdering::Ordered(3)),
}
*/
//up to three frames in flight, dropping new frame requests when all three are busy, and dropping output frames when one renders out of order

pub fn new(
	mut graphics:graphics::GraphicsState,
	mut config:wgpu::SurfaceConfiguration,
	surface:wgpu::Surface<'_>,
	device:wgpu::Device,
	queue:wgpu::Queue,
)->crate::compat_worker::INWorker<'_,Instruction>{
	crate::compat_worker::INWorker::new(move |ins:Instruction|{
		match ins{
			Instruction::ChangeMap(map)=>{
				graphics.clear();
				graphics.generate_models(&device,&queue,&map);
			},
			Instruction::Resize(size,user_settings)=>{
				println!("Resizing to {:?}",size);
				let t0=std::time::Instant::now();
				config.width=size.width.max(1);
				config.height=size.height.max(1);
				surface.configure(&device,&config);
				graphics.resize(&device,&config,&user_settings);
				println!("Resize took {:?}",t0.elapsed());
			}
			Instruction::Render(frame_state)=>{
				//this has to go deeper somehow
				let frame=match surface.get_current_texture(){
					Ok(frame)=>frame,
					Err(_)=>{
						surface.configure(&device,&config);
						surface
							.get_current_texture()
							.expect("Failed to acquire next surface texture!")
					}
				};
				let view=frame.texture.create_view(&wgpu::TextureViewDescriptor{
					format:Some(config.view_formats[0]),
					..wgpu::TextureViewDescriptor::default()
				});

				graphics.render(&view,&device,&queue,frame_state);

				frame.present();
			}
		}
	})
}
